/*---------------------------------------------------------------------------
File:         			BeginParenthesis.java
Package:                        JFLAP Version 3.1
Author:			        Ted Hung
                                
Description of Contents:	Contains class BeginParenthesis.
				
--------------------------------------------------------------------------*/

/* 
 * Susan H. Rodger, Magda Procopiuc, Octavian Procopiuc, Eric Gramond, Ted Hung
 * Computer Science Department
 * Duke University
 * August 1999
 * Supported by National Science Foundation DUE-9596002, DUE-9555084,
 *  and DUE-9752583
 *
 * Copyright (c) 1999
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the author.  The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

package flap.operators;

import flap.*;
import java.util.*;
import java.awt.*;

//
//
// BeginParenthesis
//
//
public class BeginParenthesis extends Operator
{
   public BeginParenthesis()
   {
   }

   /**
    * returns the identifier that is specific to the
    * operator
    */
   public String getIdentifier()
   {
      return "(";
   }

   /**
    * returns the priority of the given operator
    * so operator precedence can be handled
    */
   public int getPriority()
   {
      return 0;
   }

   /**
    * returns the number of arguments that this operator
    * pops off of the stack
    */
   public int numArguments()
   {
      return 0;
   }

   /**
    * returns whether the result of this operator can be concatenated with
    * for example "a*b", a* can be concatenated with
    * but not "a+bc", "a+b" cannot be concatenated with
    */
   public boolean canConcatenate()
   {
      return false;
   }

   /**
    * clones the operator so it can be used in a factory
    */
   public Operator Clone()
   {
      return new BeginParenthesis();
   }
   
   /**
    * executes the given operator on the given operands
    */
   public String execute(Stack operands)
   {
      return "(";
   }

}

